



#include "crypteasek1024.h"
#include <fcntl.h>
#include <unistd.h>
#include <sys/types.h>


// Register Global File Descriptors //
int g_fd_input = -1;
int g_fd_output = -1;

int64_t *g_ptr_input_buffer_encrypt = NULL;
int64_t *g_ptr_output_buffer_encrypt = NULL;

int64_t *g_ptr_input_buffer_decrypt = NULL;
int64_t *g_ptr_output_buffer_decrypt = NULL;

int64_t g_key_bitwise_one = 0;

int g_bytes_read;
// Allocate the buffer memory ot 8 Bytes * 1024
#define MEMORY_BLOCK  1024 * 1024
// Divider for the 4 ( four ) encryption keys//
#define COUNTER_DIVIDER 8

// Memory Counter //
int64_t g_counter_memory_int64 = 0;
// Crypte keys Data Holder //
struct crypt_keys_caesar g_struct_crypt_keys_caesar;
struct crypt_keys_bitwise g_struct_crypt_keys_bitwise;

// Setter //
//
void set_file_memory_cache(int64_t cache_size){

}
void set_crypt_keys_bitwise(crypt_keys_bitwise_t my_crypt_bitwise){
    g_struct_crypt_keys_bitwise = my_crypt_bitwise;
}
void set_crypt_keys_caesar(crypt_keys_caesar_t my_crypt_caesar){
    g_struct_crypt_keys_caesar = my_crypt_caesar;
}

//
void clear_main_int_array(int64_t **ptr_buffer){
    memset((*ptr_buffer),0,g_counter_memory_int64);

}
void malloc_main_int_array(int64_t **ptr_buffer,int size_memory){
    g_counter_memory_int64 = size_memory;
    (*ptr_buffer) = (int64_t * ) malloc(size_memory);
    if ( (*ptr_buffer) ){
         memset((*ptr_buffer),0,size_memory);
    }
}
void malloc_main_char_array(unsigned char **ptr_buffer,int size_memory){
    int alloc_memory = sizeof(unsigned char) * size_memory;
    (*ptr_buffer) = (unsigned char * ) malloc(alloc_memory);
    if ( (*ptr_buffer) ){
        memset((*ptr_buffer),0,alloc_memory);
    }

}
int lowlevel_open_file_read(char *ptr_file_name_input){
    int fd_input ;
    fd_input = open(ptr_file_name_input,O_RDONLY);
    if ( fd_input < 0 ){
        printf("Error opening file.\n");
    }
    return fd_input;
}
int lowlevel_open_file_write(char *ptr_file_name_input){
    int fd_input ;
    mode_t mode = S_IRUSR | S_IWUSR | S_IRGRP;
    fd_input = open(ptr_file_name_input,O_RDWR|O_CREAT|O_TRUNC, mode);
    if ( fd_input < 0 ){
        printf("Error opening file.\n");
    }
    return fd_input;
}
void pre_file_opener(char *ptr_in_fn,char *ptr_out_fn){
    g_fd_input  = lowlevel_open_file_read(ptr_in_fn);
    g_fd_output = lowlevel_open_file_write(ptr_out_fn);

}
int64_t read_file(int file_block){
    g_bytes_read = read(g_fd_input,g_ptr_input_buffer_encrypt,file_block);
    printf("READ_FILE:Readed bytes: %d\n",g_bytes_read);
    return g_bytes_read;
}

int64_t encrypt_bitwise_with_key(int64_t original_data, int64_t bitwise_key){
    int64_t ret_bitwise_encrypted = 0;
    ret_bitwise_encrypted = original_data ^  bitwise_key;
    return ret_bitwise_encrypted;
}
int64_t decrypt_bitwise_with_key(int64_t raw_data,int64_t bitwise_key){
    int64_t ret_bitwise_decrypted = 0;
    ret_bitwise_decrypted = raw_data ^  bitwise_key;
    return ret_bitwise_decrypted;
}
int64_t encrypt_caesar_with_key(int64_t original_data,int64_t caesar_key){
    int64_t ret_caesar_encrypted = 0;
    ret_caesar_encrypted = original_data + caesar_key;
    return ret_caesar_encrypted;

}
int64_t decrypt_caesar_with_key(int64_t encrypted_data,int64_t caesar_key){
    int64_t ret_caesar_decrypted = 0;
    ret_caesar_decrypted = encrypted_data - caesar_key;
    return ret_caesar_decrypted;
}

void go_through_read_data_encrypted(int64_t readed_bytes){
    int64_t cycle_buffer = 0;
    int64_t encrypted_bitwise_data = 0;
    int64_t encrypted_caesar_data = 0;
    int64_t int64_data = 0;
    int64_t max_data_cycle = 0;

    int e = readed_bytes % (sizeof(int64_t));
    if ( e == 0){
        max_data_cycle = MEMORY_BLOCK ;
        printf("Encrypt:: Modulo 0.\n");
    } else if ( e != 0){
        printf("Encrypt:: modulo not null.\n");
        max_data_cycle = MEMORY_BLOCK + 1;
    }
    int remainder =0;
    for(cycle_buffer = 0; cycle_buffer < max_data_cycle ; cycle_buffer++){
        remainder = cycle_buffer % COUNTER_DIVIDER;
        int64_data = g_ptr_input_buffer_encrypt[cycle_buffer];
        printf("Encrypt::buffered read data: %ld\n",int64_data);
        if ( remainder == 0 ){
            // First Caesar //
            encrypted_caesar_data = encrypt_caesar_with_key(int64_data,
                    g_struct_crypt_keys_caesar.crypt_key_caesar_one);
            // Second bitwise XOR //
            encrypted_bitwise_data = encrypt_bitwise_with_key(encrypted_caesar_data,
                    g_struct_crypt_keys_bitwise.crypt_key_bitwise_one);

          g_ptr_output_buffer_encrypt[cycle_buffer] = encrypted_bitwise_data;

        } else if ( remainder == 1){
            // First Caesar //
            encrypted_caesar_data = encrypt_caesar_with_key(int64_data,
                    g_struct_crypt_keys_caesar.crypt_key_caesar_two);
            // Second bitwise XOR //
            encrypted_bitwise_data = encrypt_bitwise_with_key(encrypted_caesar_data,
                    g_struct_crypt_keys_bitwise.crypt_key_bitwise_two);

          g_ptr_output_buffer_encrypt[cycle_buffer] = encrypted_bitwise_data;


        } else if ( remainder == 2){
            // First Caesar //
            encrypted_caesar_data = encrypt_caesar_with_key(int64_data,
                    g_struct_crypt_keys_caesar.crypt_key_caesar_three);
            // Second bitwise XOR //
            encrypted_bitwise_data = encrypt_bitwise_with_key(encrypted_caesar_data,
                    g_struct_crypt_keys_bitwise.crypt_key_bitwise_three);

          g_ptr_output_buffer_encrypt[cycle_buffer] = encrypted_bitwise_data;

        } else if ( remainder == 3){
            // First Caesar //
            encrypted_caesar_data = encrypt_caesar_with_key(int64_data,
                    g_struct_crypt_keys_caesar.crypt_key_caesar_four);
            // Second bitwise XOR //
            encrypted_bitwise_data = encrypt_bitwise_with_key(encrypted_caesar_data,
                    g_struct_crypt_keys_bitwise.crypt_key_bitwise_four);

          g_ptr_output_buffer_encrypt[cycle_buffer] = encrypted_bitwise_data;


        } else if ( remainder == 4 ){
          // First Caesar //
          encrypted_caesar_data = encrypt_caesar_with_key (int64_data,
                    g_struct_crypt_keys_caesar.crypt_key_caesar_five);
          // Second Bitwise Xor //
          encrypted_bitwise_data = encrypt_bitwise_with_key (encrypted_caesar_data,
                    g_struct_crypt_keys_bitwise.crypt_key_bitwise_five);

          g_ptr_output_buffer_encrypt[cycle_buffer] = encrypted_bitwise_data;
        } else if ( remainder == 5){
          // First Caesar //
          encrypted_caesar_data = encrypt_caesar_with_key (int64_data,
                    g_struct_crypt_keys_caesar.crypt_key_caesar_six);
          // Second Bitwise Xor //
          encrypted_bitwise_data = encrypt_bitwise_with_key (encrypted_caesar_data,
                    g_struct_crypt_keys_bitwise.crypt_key_bitwise_six);

          g_ptr_output_buffer_encrypt[cycle_buffer] = encrypted_bitwise_data;



        } else if ( remainder == 6){
          // First Caesar //
          encrypted_caesar_data = encrypt_caesar_with_key (int64_data,
                    g_struct_crypt_keys_caesar.crypt_key_caesar_seven);
          // Second Bitwise Xor //
          encrypted_bitwise_data = encrypt_bitwise_with_key (encrypted_caesar_data,
                    g_struct_crypt_keys_bitwise.crypt_key_bitwise_seven);
          g_ptr_output_buffer_encrypt[cycle_buffer] = encrypted_bitwise_data;

        } else if ( remainder == 7){
                    // First Caesar //
          encrypted_caesar_data = encrypt_caesar_with_key (int64_data,
                    g_struct_crypt_keys_caesar.crypt_key_caesar_eight);
          // Second Bitwise Xor //
          encrypted_bitwise_data = encrypt_bitwise_with_key (encrypted_caesar_data,
                    g_struct_crypt_keys_bitwise.crypt_key_bitwise_eight);

          g_ptr_output_buffer_encrypt[cycle_buffer] = encrypted_bitwise_data;

        }
        printf("Encrypt: buffer cycle: %ld\n",cycle_buffer);
        printf("Encrypt: output buffer data: %ld\n",g_ptr_output_buffer_encrypt[cycle_buffer]);

    }
}
void go_through_read_data_decrypted(int64_t readed_bytes){
    int64_t cycle_buffer = 0;
    int64_t decrypted_bitwise_data = 0;
    int64_t decrypted_caesar_data = 0;
    int64_t raw_data = 0;
    int64_t max_data_cycle = 0;

    int e = readed_bytes % (sizeof(int64_t));
    if ( e == 0){
        max_data_cycle = MEMORY_BLOCK ;
        printf("Encrypt:: Modulo 0.\n");
    } else if ( e != 0){
        printf("Encrypt:: modulo not null.\n");
        max_data_cycle = MEMORY_BLOCK + 1;
    }

        int remainder = 0;
    for(cycle_buffer = 0; cycle_buffer < max_data_cycle ; cycle_buffer++){
        remainder = cycle_buffer % COUNTER_DIVIDER;
        raw_data = g_ptr_input_buffer_decrypt[cycle_buffer];
        if ( remainder == 0 ){
            // First Bitwise XOR //
            decrypted_bitwise_data = decrypt_bitwise_with_key(raw_data,
                    g_struct_crypt_keys_bitwise.crypt_key_bitwise_one);
            // Second Caesar decrypt //
            decrypted_caesar_data = decrypt_caesar_with_key(decrypted_bitwise_data,
                    g_struct_crypt_keys_caesar.crypt_key_caesar_one);

            g_ptr_output_buffer_decrypt[cycle_buffer] = decrypted_caesar_data;
        } else if ( remainder == 1) {
            // First Bitwise XOR //
            decrypted_bitwise_data = decrypt_bitwise_with_key(raw_data,
                    g_struct_crypt_keys_bitwise.crypt_key_bitwise_two);
            // Second Caesar decrypt //
            decrypted_caesar_data = decrypt_caesar_with_key(decrypted_bitwise_data,
                    g_struct_crypt_keys_caesar.crypt_key_caesar_two);
            g_ptr_output_buffer_decrypt[cycle_buffer] = decrypted_caesar_data;

        } else if ( remainder == 2) {
            // First Bitwise XOR //
            decrypted_bitwise_data = decrypt_bitwise_with_key(raw_data,
                    g_struct_crypt_keys_bitwise.crypt_key_bitwise_three);
            // Second Caesar decrypt //
            decrypted_caesar_data = decrypt_caesar_with_key(decrypted_bitwise_data,
                    g_struct_crypt_keys_caesar.crypt_key_caesar_three);
            g_ptr_output_buffer_decrypt[cycle_buffer] = decrypted_caesar_data;

        } else if ( remainder == 3) {
            // First Bitwise XOR //
            decrypted_bitwise_data = decrypt_bitwise_with_key(raw_data,
                    g_struct_crypt_keys_bitwise.crypt_key_bitwise_four);
            // Second Caesar decrypt //
            decrypted_caesar_data = decrypt_caesar_with_key(decrypted_bitwise_data,
                    g_struct_crypt_keys_caesar.crypt_key_caesar_four);

            g_ptr_output_buffer_decrypt[cycle_buffer] = decrypted_caesar_data;

        } else if ( remainder == 4){
            // First Bitwise XOR //
            decrypted_bitwise_data = decrypt_bitwise_with_key(raw_data,
                    g_struct_crypt_keys_bitwise.crypt_key_bitwise_five);
            // Second Caesar decrypt //
            decrypted_caesar_data = decrypt_caesar_with_key(decrypted_bitwise_data,
                    g_struct_crypt_keys_caesar.crypt_key_caesar_five);

          g_ptr_output_buffer_decrypt[cycle_buffer] = decrypted_caesar_data;

        } else if ( remainder == 5){
            // First Bitwise XOR //
            decrypted_bitwise_data = decrypt_bitwise_with_key(raw_data,
                    g_struct_crypt_keys_bitwise.crypt_key_bitwise_six);
            // Second Caesar decrypt //
            decrypted_caesar_data = decrypt_caesar_with_key(decrypted_bitwise_data,
                    g_struct_crypt_keys_caesar.crypt_key_caesar_six);

          g_ptr_output_buffer_decrypt[cycle_buffer] = decrypted_caesar_data;

        } else if ( remainder == 6){
            // First Bitwise XOR //
            decrypted_bitwise_data = decrypt_bitwise_with_key(raw_data,
                    g_struct_crypt_keys_bitwise.crypt_key_bitwise_seven);
            // Second Caesar decrypt //
            decrypted_caesar_data = decrypt_caesar_with_key(decrypted_bitwise_data,
                    g_struct_crypt_keys_caesar.crypt_key_caesar_seven);

          g_ptr_output_buffer_decrypt[cycle_buffer] = decrypted_caesar_data;

        } else if ( remainder == 7){
            // First Bitwise XOR //
            decrypted_bitwise_data = decrypt_bitwise_with_key(raw_data,
                    g_struct_crypt_keys_bitwise.crypt_key_bitwise_eight);
            // Second Caesar decrypt //
            decrypted_caesar_data = decrypt_caesar_with_key(decrypted_bitwise_data,
                    g_struct_crypt_keys_caesar.crypt_key_caesar_eight);

          g_ptr_output_buffer_decrypt[cycle_buffer] = decrypted_caesar_data;

        }

    }
}

int64_t file_stat_seek_size(void){
    int64_t file_size = 0;
    file_size = lseek(g_fd_input,0,SEEK_END);
    // Set back the position to file start //
    lseek(g_fd_input,0,SEEK_SET);
    return file_size;
}
int64_t file_chunker(int64_t file_size_bytes, int64_t read_blocks){
    int64_t file_chunk_piece=0;
    int64_t remainder =-1;
    file_chunk_piece = file_size_bytes / read_blocks;
    remainder = file_size_bytes % read_blocks;
    if ( remainder == 0){
        printf("Calculated file_chunk_size: %ld\n",file_chunk_piece);
        return file_chunk_piece;
    } else {
        file_chunk_piece = file_chunk_piece + 1;
        printf("Calculated file_chunk_size: %ld\n",file_chunk_piece);
        return file_chunk_piece;
    }

}
void block_copy_encrypt(char *ptr_fn_in,char *ptr_fn_out){
    int64_t file_size_bytes = 0;
    pre_file_opener(ptr_fn_in,ptr_fn_out);
    file_size_bytes = file_stat_seek_size();
    printf("BLOCK_COPY:File size in bytes: %ld\n",file_size_bytes);
    int64_t read_block = sizeof(int64_t) * MEMORY_BLOCK;
    int64_t chunks = file_chunker(file_size_bytes,read_block);
    printf("BLOCK_COPY:Chunks: %ld\n",chunks);
    int64_t read_cycle = 0;
    int retvalue_read_bytes = 0;
    int retvalue_write = 0;

    malloc_main_int_array(&g_ptr_input_buffer_encrypt,read_block);
    malloc_main_int_array(&g_ptr_output_buffer_encrypt,read_block);

   // int64_t encrypted_bitwise =0;
    for(read_cycle = 0; read_cycle < chunks ; read_cycle++){
        printf("Encrypt:Read cycle: %ld \n",read_cycle);
        retvalue_read_bytes = read(g_fd_input,g_ptr_input_buffer_encrypt,read_block);
        printf("Encrypt:Readed bytes value: %d\n",retvalue_read_bytes);
        go_through_read_data_encrypted(retvalue_read_bytes);


        // Write function need the read successfully readed //
        // byte to write out data //
        // write(..,..,retvalue_read); //
        retvalue_write = write(g_fd_output,g_ptr_output_buffer_encrypt,retvalue_read_bytes);
        printf("Encrypt:Write value: %d\n",retvalue_write);
        clear_main_int_array(&g_ptr_input_buffer_encrypt);
        clear_main_int_array(&g_ptr_output_buffer_encrypt);
    }

    close_files();
}
void block_copy_decrypt(char *ptr_fn_in,char *ptr_fn_out){
    int64_t file_size_bytes = 0;
    pre_file_opener(ptr_fn_in,ptr_fn_out);
    file_size_bytes = file_stat_seek_size();
    printf("decrypt:File size in bytes: %ld\n",file_size_bytes);
    int64_t read_block = sizeof(int64_t) * MEMORY_BLOCK ;
    int64_t chunks = file_chunker(file_size_bytes,read_block);
    printf("decrypt:Chunks: %ld\n",chunks);
    int64_t read_cycle = 0;
    int retvalue_read_bytes = 0;
    int retvalue_write_bytes = 0;

    malloc_main_int_array(&g_ptr_input_buffer_decrypt,read_block);
    malloc_main_int_array(&g_ptr_output_buffer_decrypt,read_block);

    for(read_cycle = 0; read_cycle < chunks ; read_cycle++){
        printf("decrypt: Read cycle: %ld \n",read_cycle);
        retvalue_read_bytes = read(g_fd_input,g_ptr_input_buffer_decrypt,read_block);
        printf("decrypt: Read value: %d\n",retvalue_read_bytes);
        go_through_read_data_decrypted(retvalue_read_bytes);

        // Write function need the read successfully readed //
        // byte to write out data //
        // write(..,..,retvalue_read); //
        retvalue_write_bytes = write(g_fd_output,g_ptr_output_buffer_decrypt,retvalue_read_bytes);
        printf("decrypt: Write value: %d\n",retvalue_write_bytes);
        clear_main_int_array(&g_ptr_input_buffer_decrypt);
        clear_main_int_array(&g_ptr_output_buffer_decrypt);
    }
    close_files();
}

void close_files(void){
    if ( g_fd_input > 0){
        close(g_fd_input);
    }
    if ( g_fd_output > 0){
        close(g_fd_output);
    }
}


