
#ifndef _CRYPTEASEK1024_H_
#define _CRYPTEASEK1024_H_

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

typedef struct crypt_keys_bitwise {
    int64_t crypt_key_bitwise_one;
    int64_t crypt_key_bitwise_two;
    int64_t crypt_key_bitwise_three;
    int64_t crypt_key_bitwise_four;
    int64_t crypt_key_bitwise_five;
    int64_t crypt_key_bitwise_six;
    int64_t crypt_key_bitwise_seven;
    int64_t crypt_key_bitwise_eight;
} crypt_keys_bitwise_t;

typedef struct crypt_keys_caesar {
    int64_t crypt_key_caesar_one;
    int64_t crypt_key_caesar_two;
    int64_t crypt_key_caesar_three;
    int64_t crypt_key_caesar_four;
    int64_t crypt_key_caesar_five;
    int64_t crypt_key_caesar_six;
    int64_t crypt_key_caesar_seven;
    int64_t crypt_key_caesar_eight;
} crypt_keys_caesar_t;


FILE *file_open_read(char *ptr_file_name);
FILE *file_open_write(char *ptr_file_name);

void malloc_main_int_array(int64_t **ptr_buffer,int size_memory);
void malloc_main_char_array(unsigned char **ptr_buffer,int size_memory);

void set_crypt_keys_bitwise(crypt_keys_bitwise_t my_bitwise_key);
void set_crypt_keys_caesar(crypt_keys_caesar_t my_caesar_key);

int64_t encrypt_bitwise_with_key(int64_t original_data,int64_t key_bitwise);
int64_t decrypt_bitwise_with_key(int64_t encrypted_data, int64_t key_bitwise);

int64_t encrypt_caesar_with_key(int64_t original_data,int64_t key_caesar);
int64_t decrypt_caesar_with_key(int64_t encrypted_data,int64_t key_caesar);

void pre_file_opener(char *ptr_in,char *ptr_out);
int64_t read_file(int read_block);
int64_t file_chunker(int64_t file_size_bytes,int64_t read_blocks);

void go_through_read_data_encrypted(int64_t readed_bytes);
void go_through_read_data_decrypted(int64_t readed_bytes);

void block_copy_encrypt(char *ptr_fn_in, char *ptr_fn_out);
void block_copy_decrypt(char *ptr_fn_in, char *ptr_fn_out);

void close_files(void);

#endif

